#include "ehs/io/BaseFileMonitor.h"

namespace ehs
{
	BaseFileMonitor::BaseFileMonitor(Str_8 filePath)
		: filePath((Str_8&&)filePath)
	{
	}

	BaseFileMonitor::BaseFileMonitor(BaseFileMonitor&& fm) noexcept
		: filePath((Str_8&&)fm.filePath)
	{
	}

	BaseFileMonitor::BaseFileMonitor(const BaseFileMonitor& fm)
		: filePath(fm.filePath)
	{
	}

	BaseFileMonitor& BaseFileMonitor::operator=(BaseFileMonitor&& fm) noexcept
	{
		if (this == &fm)
			return *this;

		filePath = (Str_8&&)fm.filePath;

		return *this;
	}

	BaseFileMonitor& BaseFileMonitor::operator=(const BaseFileMonitor& fm)
	{
		if (this == &fm)
			return *this;

		filePath = fm.filePath;

		return *this;
	}

	Str_8 BaseFileMonitor::GetFilePath() const
	{
		return filePath;
	}

	bool BaseFileMonitor::IsValid() const
	{
		return filePath.Size();
	}
}