#include "ehs/io/socket/ehc/NetOp.h"
#include "ehs/io/socket/EHC.h"
#include "ehs/io/socket/ehc/NetEnd.h"

namespace ehs
{
	NetOp::NetOp()
		: id(0)
	{
	}

	NetOp::NetOp(Str_8 name)
		: id(name.Hash_64()), name((Str_8 &&)name)
	{
	}

	NetOp::NetOp(NetOp&& op) noexcept
		: id(op.id), name((Str_8 &&)op.name)
	{
		op.id = 0;
	}

	NetOp::NetOp(const NetOp &op)
		: id(op.id), name(op.name)
	{
	}

	NetOp& NetOp::operator=(NetOp&& op) noexcept
	{
		if (this == &op)
			return *this;

		id = op.id;
		name = (Str_8 &&)op.name;

		op.id = 0;

		return *this;
	}

	NetOp &NetOp::operator=(const NetOp &op)
	{
		if (this == &op)
			return *this;

		id = op.id;
		name = op.name;

		return *this;
	}

	UInt_64 NetOp::GetId() const
	{
		return id;
	}

	Str_8 NetOp::GetName() const
	{
		return name;
	}

	void NetOp::Execute(NetChannel *channel, NetEnd *endpoint, NetSys *sys, Serializer<UInt_64> &payload)
	{
	}
}